//==============================================================================//
//				DirectX9pėpCu Luna									//
//==============================================================================//
//																				//
//	ŐVł̒uĂURL														//
//																				//
//		TWINTAIL LOVERS.														//
//			http://www.twin-tail.jp/											//
//																				//
//	ⓙꏊ																//
//																				//
//		BBS																		//
//			TWINTAIL LOVERS.̌f											//
//																				//
// DirectX Library "Luna for DirectX 9.0c"										//
// Copyright (C) 2003-2005 t`												//
// All rights reserved.															//
//																				//
//==============================================================================//

/** @file
    @brief		xNgZNX
    @author		t`
    @since		2003.07.01
*/

#ifndef ___LUNAVECTOR3_H___
#define ___LUNAVECTOR3_H___


//=============================================================================
// INCLUDE
//=============================================================================
#include "dx_select.hpp"
#include "LunaBase.h"

//=============================================================================
/**
	@brief	xNgZNX

	xNg֘ȀeՂɂ邽߂̃NXłB
	D3DXVECTOR3^̔hȂ̂ŃLXg邱ƂȂ
	̂܂ܓ悤ɎgƂo܂B

    @todo	------------------------
    @bug	------------------------
*/
//=============================================================================
namespace lunadxmath{

class CVector3 : public D3DXVECTOR3
{
public:
	//==========================================================================
	/**	RXgN^
	*/
	CVector3()
	{
	}

	//==========================================================================
	/**	RXgN^

		@param v		[in] ɎgxNg
	*/
	CVector3( const CVector3 &v )
	{
		*this = v;
	}

	//==========================================================================
	/**	RXgN^

		@param v		[in] ɎgxNg
	*/
	CVector3( const D3DXVECTOR3 &v )
	{
		this->x = v.x;
		this->y = v.y;
		this->z = v.z;
	}

	//==========================================================================
	/**	RXgN^

		@param fPx		[in] Ɏgwl
		@param fPy		[in] Ɏgxl
		@param fPz		[in] Ɏgyl
	*/
	CVector3( Float fPx, Float fPy, Float fPz )
	{
		x = fPx;
		y = fPy;
		z = fPz;
	}

	void Add( CVector3 *pIn1, CVector3 *pIn2 );							///< xNgZ
	void Sub( CVector3 *pIn1, CVector3 *pIn2 );							///< xNgZ
	void Set( Float fPx, Float fPy, Float fPz );						///< xNgݒ

	Float LengthSq( void );												///< ̓擾
	Float Length( void );												///< 擾
	Float DotProduct( CVector3 *pIn );									///< wxNgƂ̓ώ擾

	void Normalize( void );												///< K
	void CrossProduct( CVector3 *pIn1, CVector3 *pIn2 );				///< w肳ꂽQxNgƂ̊Oώ擾
	void Reflect( CVector3 *pIn1, CVector3 *pIn2 );						///< w肳ꂽQxNgƂ̔˃xNg擾
	void TransformNormal( CVector3 *pIn1, class CMatrix *pIn2 );		///< wxNgł̖@ϊ
	void TransformCoord( CVector3 *pIn1, class CMatrix *pIn2 );			///< wxNgł̍Wϊ
	void TransformProjection( CVector3 *pIn1, class CMatrix *pIn2 );	///< wxNgł̓ϊ

	void Normalize( CVector3 *pIn );									///< wxNg𐳋K
	void CrossProduct( CVector3 *pIn );									///< wxNgƂ̊Oώ擾
	void Reflect( CVector3 *pIn );										///< wxNgł̔˃xNg擾
	void TransformNormal( class CMatrix *pIn );							///< wsł̖@ϊ
	void TransformCoord( class CMatrix *pIn );							///< wsł̍Wϊ
	void TransformProjection( class CMatrix *pIn );						///< wsł̓ϊ

	void RotationX( Sint32 Angle );										///< w]
	void RotationY( Sint32 Angle );										///< x]
	void RotationZ( Sint32 Angle );										///< y]
	void RotationAxis( Sint32 Angle, CVector3 *pAxis );					///< Cӎ]
	void Rotation( Sint32 rotx, Sint32 roty, Sint32 rotz );					///< Rŉ]
	void Scaling( Float sx, Float sy, Float sz );						///< XP[O
	void Translation( Float px, Float py, Float pz );					///< ړ

    CVector3& operator += ( const CVector3& );
    CVector3& operator -= ( const CVector3& );
    CVector3& operator *= ( Float );
    CVector3& operator /= ( Float );

    CVector3 operator + () const;
    CVector3 operator - () const;

    CVector3 operator + ( const CVector3& ) const;
    CVector3 operator - ( const CVector3& ) const;
    CVector3 operator * ( Float ) const;
    CVector3 operator / ( Float ) const;
};

}//eon
#endif // ___LUNAVECTOR3_H___
