//==============================================================================//
//				DirectX9pėpCu Luna									//
//==============================================================================//
//																				//
//	ŐVł̒uĂURL														//
//																				//
//		TWINTAIL LOVERS.														//
//			http://www.twin-tail.jp/											//
//																				//
//	ⓙꏊ																//
//																				//
//		BBS																		//
//			TWINTAIL LOVERS.̌f											//
//																				//
// DirectX Library "Luna for DirectX 9.0c"										//
// Copyright (C) 2003-2005 t`												//
// All rights reserved.															//
//																				//
//==============================================================================//

/** @file
    @brief		pNX
    @author		t`
    @since		2003.07.01
*/

#ifndef ___LUNASTYLE_H___
#define ___LUNASTYLE_H___


//=============================================================================
// INCLUDE
//=============================================================================

#include "LunaVector3.h"
#include "LunaMatrix.h"
#include "LunaQuaternion.h"

namespace lunadxmath{
//=============================================================================
/**
	@brief	pNX

	R\xNgpĎps
	ׂ̃NXłB
	{Iɂ͊eRc֘ÃIuWFNgɂ
	̃NX܂܂ĂAꂳꂽ@
	p̐sƂo悤ɂȂĂ܂B
	قƂǂ̏ꍇAbp[ォ瑀삷邱ƂɂȂ܂̂ŁA
	ڂ̃NXgp@͋HƎv܂B

    @todo	------------------------
    @bug	------------------------
*/
//=============================================================================
class CStyle
{
protected:
	CMatrix m_mStyle;												///< pps
	CMatrix m_mStyleInverse;										///< p̋ts
	CMatrix m_mTransform;											///< ϊs
	CMatrix m_mTransformInverse;									///< ϊs̋ts
	CVector3 m_vUp;													///< xNg
	CVector3 m_vRight;												///< ExNg
	CVector3 m_vFront;												///< OxNg
	CVector3 m_vPosition;											///< ʒuxNg
	CVector3 m_vScale;												///< gkxNg

public:
	CStyle();														///< RXgN^
	CStyle( const CStyle &Style );									///< RXgN^

	void Set( CStyle *pStyle );										///< pf[^Rs[
	void Get( CStyle *pStyle );										///< pf[^Rs[

	void TransformInit( void );										///< ϊ
	void TransformUpdate( void );									///< ϊXV

	void RotationX( Uint32 Rot );									///< w]
	void RotationY( Uint32 Rot );									///< x]
	void RotationZ( Uint32 Rot );									///< y]
	void Pitching( Uint32 Rot );									///< sb`O
	void Heading( Uint32 Rot );										///< wbfBO
	void Rolling( Uint32 Rot );										///< [O
	void RotationQuaternion( CQuaternion *pQuat );					///< NH[^jIŉ]
	void Translation( Float fPx, Float fPy, Float fPz );			///< ړ
	void Scaling( Float fSx, Float fSy, Float fSz );				///< gk
	void LookAt( CVector3 *pEye, CVector3 *pAt, CVector3 *pUp );	///< CӍW𒍎
	void FromMatrix( CMatrix *pMat );								///< s񂩂琶
	Sint32 GetAngleX( void );										///< wpx擾
	Sint32 GetAngleY( void );										///< xpx擾
	Sint32 GetAngleZ( void );										///< ypx擾

	//==========================================================================
	/**	= Zq

		@param In		[in] Rs[X^C
	*/
	//==========================================================================
	CStyle &operator = ( const CStyle &In )			{ Set( (CStyle*)&In ); return *this; }

	//==========================================================================
	/**	ʒuݒ

		@param pPos		[in] ݒ茳ʒuxNg
	*/
	//==========================================================================
	void SetPosition( CVector3 *pPos )			{ m_vPosition = *pPos; }

	//==========================================================================
	/**	OxNgݒ

		@param pVec		[in] ݒ茳xNg
	*/
	//==========================================================================
	void SetFront( CVector3 *pVec )				{ m_vFront = *pVec; }

	//==========================================================================
	/**	ExNgݒ

		@param pVec		[in] ݒ茳xNg
	*/
	//==========================================================================
	void SetRight( CVector3 *pVec )				{ m_vRight = *pVec; }

	//==========================================================================
	/**	xNgݒ

		@param pVec		[in] ݒ茳xNg
	*/
	//==========================================================================
	void SetUp( CVector3 *pVec )				{ m_vUp = *pVec; }

	//==========================================================================
	/**	ʒu擾

		@param pPos		[ous] ʒuxNgi[
	*/
	//==========================================================================
	void GetPosition( CVector3 *pPos )			{ *pPos = m_vPosition; }

	//==========================================================================
	/**	OxNg擾

		@param pVec		[ous] xNgi[
	*/
	//==========================================================================
	void GetFront( CVector3 *pVec )				{ *pVec = m_vFront; }

	//==========================================================================
	/**	ExNg擾

		@param pVec		[ous] xNgi[
	*/
	//==========================================================================
	void GetRight( CVector3 *pVec )				{ *pVec = m_vRight; }

	//==========================================================================
	/**	xNg擾

		@param pVec		[ous] xNgi[
	*/
	//==========================================================================
	void GetUp( CVector3 *pVec )				{ *pVec = m_vUp; }

	//==========================================================================
	/**	ps擾

		@param pMat		[ous] si[
	*/
	//==========================================================================
	void GetStyle( CMatrix *pMat )				{ *pMat = m_mStyle; }

	//==========================================================================
	/**	psh̋ts擾

		@param pMat		[ous] si[
	*/
	//==========================================================================
	void GetStyleInverse( CMatrix *pMat )		{ *pMat = m_mStyleInverse; }

	//==========================================================================
	/**	ϊs擾

		@param pMat		[ous] si[
	*/
	//==========================================================================
	void GetTransform( CMatrix *pMat )			{ *pMat = m_mTransform; }

	//==========================================================================
	/**	ϊs̋ts擾

		@param pMat		[ous] si[
	*/
	//==========================================================================
	void GetTransformInverse( CMatrix *pMat )	{ *pMat = m_mTransformInverse; }
};
}//eon

#endif // ___LUNASTYLE_H___


